use <obiscad/bevel.scad>

// wire excess
ex = 0.2;

gap=0.1;
e1 = 2;
e2 = 1;

module button_base (A, B, a, b, e1, e2) {
	// bevel the button
	//-- Define the connectors for beveling the for top edges
	//-- 1st quadrant, 
	ec1 = [ [ a/2, b/2, e1/2], [0,0,1], 0 ];
	en1 = [ ec1[0],            [1,1,0], 0 ];
	ec2 = [ [-a/2, b/2, e1/2], [0,0,1], 0 ];
	en2 = [ ec2[0],            [-1,1,0], 0 ];
	ec3 = [ [ a/2,-b/2, e1/2], [0,0,1], 0 ];
	en3 = [ ec3[0],            [1,-1,0], 0 ];
	ec4 = [ [-a/2,-b/2, e1/2], [0,0,1], 0 ];
	en4 = [ ec4[0],            [-1,-1,0], 0 ];
	translate ([0, 0, e1/2+e2/2])
	difference () {
		cube([a, b, e1], center=true);
		bevel(ec1, en1, cr = 2, cres=10, l=e1+2);
		bevel(ec2, en2, cr = 2, cres=10, l=e1+2);
		bevel(ec3, en3, cr = 2, cres=10, l=e1+2);
		bevel(ec4, en4, cr = 2, cres=10, l=e1+2);
	};

 	EC1 = [ [ A/2, B/2, e1/2], [0,0,1], 0 ];
	EN1 = [ EC1[0],            [1,1,0], 0 ];
	EC2 = [ [-A/2, B/2, e1/2], [0,0,1], 0 ];
	EN2 = [ EC2[0],            [-1,1,0], 0 ];
	EC3 = [ [ A/2,-B/2, e1/2], [0,0,1], 0 ];
	EN3 = [ EC3[0],            [1,-1,0], 0 ];
	EC4 = [ [-A/2,-B/2, e1/2], [0,0,1], 0 ];
	EN4 = [ EC4[0],            [-1,-1,0], 0 ];
    translate([0, 0, e2/2])
		difference () {
			cube([A, B, e2], center=true);
			bevel(EC1, EN1, cr = 2, cres=10, l=e1+2);
			bevel(EC2, EN2, cr = 2, cres=10, l=e1+2);
			bevel(EC3, EN3, cr = 2, cres=10, l=e1+2);
			bevel(EC4, EN4, cr = 2, cres=10, l=e1+2);
	}			
}

module button_relief(A, B, a, b, e1, e2) {
    union() {
        button_base(A, B, a, b, e1, e2);
        translate([0, 0, e1+e2/2]) sphere(d=e1+e2, $fs=0.2);
    }
}

module button_groove(A, B, a, b, e1, e2) {
    difference() {
        button_base(A, B, a, b, e1, e2);
        translate([0, 0, e1+e2/2]) sphere(d=e1+e2, $fs=0.2);
    }
}


// button "close"
Ac =  9.5 - 2*gap - ex;
ac =  8.0 - 2*gap - ex;
Bc = 10.8 - 2*gap - ex;
bc = 10.1 - 2*gap - ex;
button_relief(Ac, Bc, ac, bc, e1, e2);

// button "open"
Ao =  8.7 - 2*gap - ex;
ao =  8.0 - 2*gap - ex;
Bo =  9.4 - 2*gap - ex;
bo =  8.2 - 2*gap - ex;
translate([12, 0, 0]) button_groove(Ao, Bo, ao, bo, e1, e2);


